function [BORD] = find_bound(MASK);
%% function [BORD] = find_bound(MASK)
% find indices of borders of one connex region of matrix MASK

%% 
[N1,N2]=size(MASK);


i1=[];i2=[];L=0; ii=[];
for n=1:N1
    id=find(MASK(n,:)); if ~isempty(id);i1=[i1,n]; i2=[i2,id(1)]; ii=[ii n]; end
end
lb=sub2ind([N1,N2],i1(L+1:end),i2(L+1:end));
li=ii(L+1:end);
L=length(i1);
for n=1:N1
    id=find(MASK(n,:)); if ~isempty(id);i1=[i1,n]; i2=[i2,id(end)]; ii=[ii n];end
end
rb=sub2ind([N1,N2],i1(L+1:end),i2(L+1:end));
ri=ii(L+1:end);
L=length(i1);
allid=sub2ind([N1,N2],i1,i2);
for n=1:N2
    id=find(MASK(:,n)); 
    if ~isempty(id);
        idd=sub2ind([N1,N2],id(1),n);
        if isempty(find(allid==idd)); i2=[i2,n]; i1=[i1,id(1)]; ii=[ii n]; end
    end
end
bb=sub2ind([N1,N2],i1(L+1:end),i2(L+1:end));
bi=ii(L+1:end);
L=length(i1);
allid=sub2ind([N1,N2],i1,i2);
for n=1:N2
    id=find(MASK(:,n)); 
    if ~isempty(id);
        idd=sub2ind([N1,N2],id(end),n);
        if isempty(find(allid==idd)); i2=[i2,n]; i1=[i1,id(end)]; ii=[ii n]; end
    end
end
tb=sub2ind([N1,N2],i1(L+1:end),i2(L+1:end));
ti=ii(L+1:end);

BORD.indb{1}=lb';BORD.ii{1}=li';BORD.TAG{1}='left';
BORD.indb{2}=rb';BORD.ii{2}=ri';BORD.TAG{2}='right';
BORD.indb{3}=bb';BORD.ii{3}=bi';BORD.TAG{3}='bottom';
BORD.indb{4}=tb';BORD.ii{4}=ti';BORD.TAG{4}='top';
% keyboard
for n=1:4;
    BORD.ssid{n}=[BORD.ii{n}(1),BORD.ii{n}(end)];
end