function conf=dpwave_conf(N,epsilon, cplx_flag)
% old

if nargin<2
  epsilon=1e-6;
end;
if nargin<3
  cplx_flag='complex';
end;

a0=8; % original is a0=8
%a0=4;
kend=log2(N/a0);
N_nu(1)=1;N_nu(2)=32;

%% HW
% a0=4;
% kend=log2(N/a0);
% N_nu(1)=1;N_nu(2)=32;

%N_nu(1)=1;N_nu(2)=28; % original
for k=3:kend,
  % N_nu(k)=round(N_nu(2)*sqrt(2)^(k-2)/2)*2; % !!! original
  N_nu(k)=round(N_nu(2)*sqrt(2)^(k-2)/4)*4; % to have strictly vertical orientation
end;K1=zeros(kend,1);K2=zeros(kend,1);
for k=2:kend,  
  K1(k)=a0*2^(k-2);
  Theta_len=2*pi./N_nu; % step in 
  K2(k)=floor(2*K1(k)*sin(2*pi/N_nu(k)));
end;
boxidx=zeros(sum(N_nu),4);
bc=1;
conf.xi1=[];conf.xi2=[];xi_idx=[];w=[]; K1low=zeros(size(K1));
for k=1:kend,
  switch k,
    case 1, scaletype='coarse';
%     case kend, scaletype='fine';      
    otherwise, scaletype='detail';      
  end;
  K1low(k)=ceil(K1(k)/4.*cos(8*pi/N_nu(k)))*2;
  if (k==1),
    [eta1,eta2]=meshgrid( linspace(-K1(2),K1(2),128),linspace(-K1(2),K1(2),128));
    West=fftshift(ifft2(fftshift(dpwave_window(eta1,eta2,2*K1(2),N_nu(k),scaletype))));
    West=West/max(abs(West(:)));WestBW=abs(West)>epsilon;
    box_size(k,1)=2*K1(2);
    box_size(k,2)=2*K1(2);
    oversamp(k,1)=(box_size(k,1)+2*floor((max(find(sum(WestBW,1)))-min(find(sum(WestBW,1))))/2))/box_size(k,1);
    oversamp(k,2)=(box_size(k,2)+2*floor((max(find(sum(WestBW,2)))-min(find(sum(WestBW,2))))/2))/box_size(k,2);
    [eta1,eta2]=meshgrid( -K1(2):1/oversamp(k,1):K1(2)-1,-K1(2):1/oversamp(k,1):K1(2)-1);
    conf.chi{k}=dpwave_window(eta1,eta2,2*K1(2),N_nu(k),scaletype)/sqrt(prod(oversamp(k,:)));        
    if strcmpi(cplx_flag,'real'), conf.chi{k}=conf.chi{k}/sqrt(2);end;
  else
%    [eta1,eta2]=meshgrid( linspace(K1low(k),2*K1(k),64),linspace(-K2(k),K2(k),64)); % original
    [eta1,eta2]=meshgrid( linspace(K1low(k),2*K1(k),16),linspace(-K2(k),K2(k),16));
    West=fftshift(ifft2(fftshift(dpwave_window(eta1,eta2,2*K1(k),N_nu(k),'detail'))));
    West=West/max(abs(West(:)));WestBW=abs(West)>epsilon;
    box_size(k,1)=2*K1(k)-K1low(k);
    box_size(k,2)=2*K2(k);
    oversamp(k,1)=(box_size(k,1)+2*floor((max(find(sum(WestBW,1)))-min(find(sum(WestBW,1))))/2))/box_size(k,1);
    oversamp(k,2)=(box_size(k,2)+2*floor((max(find(sum(WestBW,2)))-min(find(sum(WestBW,2))))/2))/box_size(k,2);
    [eta1,eta2]=meshgrid( linspace(K1low(k)+1/oversamp(k,1),2*K1(k),round(oversamp(k,1)*box_size(k,1))),linspace(-K2(k),K2(k)-1/oversamp(k,2),round(oversamp(k,2)*box_size(k,2)))); 
    conf.chi{k}=dpwave_window(eta1,eta2,2*K1(k),N_nu(k),scaletype)/sqrt(prod(oversamp(k,:)));
  end;
  [y1,y2]=meshgrid(1/((eta1(1,2)-eta1(1,1))*size(eta1,2))*[-size(eta1,2)/2:size(eta1,2)/2-1], 1/((eta2(2,1)-eta2(1,1))*size(eta2,1))*[-size(eta2,1)/2:size(eta2,1)/2-1]);  
%  keyboard;
  if strcmpi(cplx_flag,'real'), nu_len=ceil(N_nu(k)/2);else nu_len=N_nu(k);end;
  for nu=1:nu_len,   
    theta_l=(nu-1)*Theta_len(k);    
    z1=eta1*cos(theta_l)+eta2*sin(theta_l);
    z2=-eta1*sin(theta_l)+eta2*cos(theta_l);
    conf.xi1=[conf.xi1;z1(:)];
    conf.xi2=[conf.xi2;z2(:)];
    x1=y1*cos(theta_l)+y2*sin(theta_l);
    x2=-y1*sin(theta_l)+y2*cos(theta_l);    
    conf.x1{k}{nu}=x1;
    conf.x2{k}{nu}=x2;    
    conf.theta{k}(nu)=theta_l;
    xi_idx=[xi_idx;length(z1(:))];
    if (k==1),
      boxidx(bc,1)=1;
      boxidx(bc,2)=length(conf.chi{k}(:));
      boxidx(bc,3)=size(conf.chi{k},1);
      boxidx(bc,4)=size(conf.chi{k},2);
    else
      boxidx(bc,1)=boxidx(bc-1,2)+1;
      boxidx(bc,2)=boxidx(bc-1,2)+length(conf.chi{k}(:));
      boxidx(bc,3)=size(conf.chi{k},1);
      boxidx(bc,4)=size(conf.chi{k},2);
    end;
    w=[w;conf.chi{k}(:)];
    bc=bc+1;
    conf.xi1_0{k}{nu}=z1(ceil(size(z1,1)/2),ceil(size(z1,2)/2));
    conf.xi2_0{k}{nu}=z2(ceil(size(z1,1)/2),ceil(size(z1,2)/2));
%     conf.xi1_0{k}{nu}=z1(ceil((size(z1,1)+1)/2),ceil((size(z1,1)+1)/2));
%     conf.xi2_0{k}{nu}=z2(ceil((size(z1,1)+1)/2),ceil((size(z1,1)+1)/2));
  end;
  conf.boxgrid(k,1)=size(conf.chi{k},1);
  conf.boxgrid(k,2)=size(conf.chi{k},2);
end;
conf.N=N;
conf.K1low=K1low;
conf.K1=K1;
conf.boxidx=boxidx;
conf.epsilon=epsilon;
conf.N_nu=N_nu;
conf.box_size=box_size;
conf.cplx_flag=cplx_flag;
conf.filt=Uop(conf.xi1,conf.xi2,w.^2,conf.N,conf.N,conf.epsilon);
conf.oversamp=oversamp;
if strcmpi(cplx_flag,'real'), conf.filt=2*real(conf.filt);end;
conf.filt=fftshift(fft2(fftshift(conf.filt)));
