function dec=dpwave_dec(inputImage,conf);

[m_f,n_f]=size(inputImage);
if ((m_f~=conf.N)||(n_f~=conf.N)),
  disp('Size of function and configuration size does not agree.');
  return;
end;
Fourier_full=Voppp(conf.xi1,conf.xi2,inputImage,conf.epsilon)/conf.N;
bc=1;%box counter
for k=1:length(conf.chi)
  if strcmpi(conf.cplx_flag,'real'), nu_len=ceil(conf.N_nu(k)/2);else nu_len=conf.N_nu(k);end;
  for nu=1:nu_len,   
    FW=reshape(Fourier_full(conf.boxidx(bc,1):conf.boxidx(bc,2)),conf.boxidx(bc,3),conf.boxidx(bc,4));
    dec{k}{nu}=fftshift(ifft2(ifftshift(FW.*conf.chi{k}))).*sqrt(numel(FW)).*...
      exp(2*pi/conf.N*i*(conf.x1{k}{nu}.*conf.xi1_0{k}{nu} + conf.x2{k}{nu}.*conf.xi2_0{k}{nu}));
    bc=bc+1;
  end;
end;